POJ 3126 Prime Path (BFS)

23 篇文章 0 订阅

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

解题思路:素数打表以及对数的拆分,当该位的数字变更以后是素数并且没有被访问过,入队列!


#include <stdio.h>
#include <math.h>
#include <string.h>
#include <queue>
using namespace std;

int a[10000],count[10000];
int vis[10000],t[4];

int bfs(int n, int m){
	queue<int> Q;
	int i,j,vtemp;
	
	memset(count,0,sizeof(count));
	memset(vis,0,sizeof(vis));
	
	Q.push(n);
	
	while(!Q.empty()){
		int temp = Q.front();
		Q.pop();
		
		t[0] = temp/1000;
		t[1] = temp/100%10;
		t[2] = temp/10%10;
		t[3] = temp%10;

		if(temp == m)
			return count[temp];
			
		for(i = 0; i < 4; i ++){
			int tmp = t[i];
			
			for(j = 0; j < 10; j ++){
				if(tmp != j){
					t[i] = j;
				
					vtemp = t[0]*1000+t[1]*100+t[2]*10+t[3];
				
					if(!vis[vtemp] && a[vtemp]){
						Q.push(vtemp);
						vis[vtemp] = 1;
						count[vtemp] = count[temp] + 1;
					}
					if(vtemp == m)	return count[vtemp];	
				}
			}
			t[i] = tmp;
		}
	}
	return -1;
}

int main(){
	int i,j,flag,n,c,b;
	
	for(i = 1000; i < 10000; i ++){
		flag = 0;
		for(j = 2; j <= sqrt(i);j ++){
			if(i % j == 0){
				flag = 1;
				break;
			}
		}
		if(flag==0)
			a[i] = 1;
	}
	
	scanf("%d",&n);
	
	while(n --){
		scanf("%d%d",&c,&b);
		int ans;
		
		ans = bfs(c,b); 
		
		if(ans < 0)
			printf("Impossible\n");
		else
			printf("%d\n",ans);
	}
	
	return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值